--- SAVED VARIABLES ---
table_Dungeon_Name = {}
table_Dungeon_Difficulty = {}
table_Time = {}
table_Looted_Item_Value_Total = {}
table_Looted_Money_Total = {}
table_Money_Total = {}
table_Character_Name = {}
table_Character_Class = {}
table_Item_Level = {}
table_Date = {}
table_LootedItems = {}
table_LootedItemsQuantity = {}
DB = {}
goldframex = ""
goldframey = ""
goldframealign1 = "CENTER"
customframex = ""
customframey = ""
customframealign1 = "CENTER"
LiveGold = "ON"
MinGold = 0
MinTime = 0
maintable = 1
CustomPrice = "vendorsell"
CustomPriceStorage = {"dbmarket", "dbmarket", "dbmarket", "dbmarket", "dbmarket"}
currentlocation = GetZoneText()
currentlocation1 = GetSubZoneText()
localizedClass, englishClass, classIndex = UnitClass("player")
pause = 0

--- VARIABLES ---
local select, tostring, time, unpack, tonumber, floor, pairs, tinsert, smatch, math, gsub = select, tostring, time, unpack, tonumber, floor, pairs, table.insert, string.match, math, gsub
data = {}
local sortdirection = true
local timer_Status = 0
local PATTERN_LOOT_ITEM_SELF = LOOT_ITEM_SELF:gsub("%%s", "(.+)")
local PATTERN_LOOT_ITEM_SELF_MULTIPLE = LOOT_ITEM_SELF_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)")
local player_name, player_realm = UnitName("player")
local difficulty_lastDungen = ""	
looted_money_total = 0
sell_value_total = 0		
local LootedItems = {}
local LootedItemsQuantity = {}
local CustomLootedItems = {}
local CustomLootedItemsQuantity = {}
MyAddon = LibStub("AceAddon-3.0"):NewAddon("Instance Gold Tracker", "AceConsole-3.0")
MyConsole = LibStub("AceConsole-3.0")
local tipsToModify = {
    "GameTooltip",
    "ItemRefTooltip",
};

--- MINIMAP BUTTON ---
local LDB = LibStub("LibDataBroker-1.1"):NewDataObject("Instance Gold Tracker", {
type = "data source",
text = "Instance Gold Tracker",
icon = "Interface\\Icons\\inv_misc_thegoldencheep",
OnTooltipShow = function(tooltip)
    tooltip:SetText("Instance Gold Tracker")
    tooltip:AddLine("/igticon to toggle minimap icon.", 1, 1, 1)
    tooltip:AddLine("/igt to open window.", 1, 1, 1)
    tooltip:AddLine("/igtcustom to open custom farm window.", 1, 1, 1)
    tooltip:Show()
end,
OnClick = function() 
    maintable = 1
    igtframe:SetShown(not igtframe:IsShown())
    dngframe:Hide()
    setTableData()
end,
})

local icon = LibStub("LibDBIcon-1.0")
function MyAddon:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("DB", { profile = { minimap = { hide = false, }, }, }) 
    icon:Register("Instance Gold Tracker", LDB, self.db.profile.minimap) 

end
function MyAddon:CommandTheBunnies() 
    self.db.profile.minimap.hide = not self.db.profile.minimap.hide 
    if self.db.profile.minimap.hide then 
        icon:Hide("Instance Gold Tracker") 
    else 
        icon:Show("Instance Gold Tracker") 
    end 
end

--- ONENABLE ---
function MyAddon:OnEnable()


--- MAIN FRAME ---
--ItemTooltip = CreateFrame( "GameTooltip", "ItemTooltip", nil, "GameTooltipTemplate" ); -- Tooltip name cannot be nil
ItemTooltip = GameTooltip
SetNoItems()
removeNoItems()


igtframe = CreateFrame("Frame", "InstanceGoldTracker", UIParent, "SimplePanelTemplate")
igtframe:SetPoint("CENTER")
igtframe:SetSize(932, 640)
igtframe:SetFrameStrata("MEDIUM")
tinsert(UISpecialFrames, "InstanceGoldTracker")

igtframe:SetMovable(true)
igtframe:EnableMouse(true)
igtframe:RegisterForDrag("LeftButton")
igtframe:SetScript("OnDragStart", igtframe.StartMoving)
igtframe:SetScript("OnDragStop", igtframe.StopMovingOrSizing)

igtframe.title = igtframe:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
igtframe.title:SetPoint("CENTER", igtframe, "TOP", 0,-17)
igtframe.title:SetText("Instance Gold Tracker")

local button = CreateFrame("button","ExitButton", igtframe, "UIPanelCloseButtonNoScripts")
button:SetPoint("TOPRIGHT", igtframe, "TOPRIGHT", 0, -1)
button:SetScript("OnClick", function(self, button, down) self:GetParent():Hide() end)

local delete = CreateFrame("button","DeleteButton", igtframe, "UIPanelButtonTemplate")
delete:SetPoint("BOTTOMLEFT", igtframe, "BOTTOMLEFT", 2, 5)
delete:SetScript("OnClick", function(self, button, down) 
    if st:GetSelection() and maintable == 1 then
    deleteEntry(getindexofentry(st:GetSelection())) 
    dngframe:Hide()
    maintable = 0
    setTableData(currententry) 
    else
        MyAddon:Print("Please select row you want to delete!")
    end
   
end)
delete:SetSize(60, 21)
delete:SetText("Delete")
delete.tooltipText = "Delete selected entry"

mainbtn = CreateFrame("button","MainButton", igtframe, "UIPanelButtonTemplate")
mainbtn:SetPoint("BOTTOM", igtframe, "BOTTOM", -6, 5)
mainbtn:SetScript("OnClick", function(self, button, down) 
    dngframe:Hide()
    maintable = 1
    setTableData()
    Dungeon_Name = table_single_dungeon_name[0]
    st.SetFilter(st, function (st, row)
            return true
    end)
end)
mainbtn:SetSize(100, 21)
mainbtn:SetText("Back")

local setbtn = CreateFrame("button","SettingsButton", igtframe, "UIPanelButtonTemplate")
setbtn:SetPoint("BOTTOMRIGHT", igtframe, "BOTTOMRIGHT", -5, 5)
setbtn:SetScript("OnClick", function(self, button, down) 
    settingsframe:SetShown(not settingsframe:IsShown())
end)
setbtn:SetSize(60, 21)
setbtn:SetText("More")

--- CREATE DUNGEONS FRAME ---
dngframe = CreateFrame("Frame", "Dungeons", igtframe, "SimplePanelTemplate")
dngframe:SetPoint("TOPRIGHT", igtframe, "TOPLEFT", 1,0)
dngframe:SetSize(300, 640)
dngframe:SetFrameStrata("DIALOG")
tinsert(UISpecialFrames, "Dungeons")
dngframe.title = dngframe:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
dngframe.title:SetPoint("CENTER", dngframe, "TOP", 0,-17)
dngframe.title:SetText("Looted Items")

--- CREATE SETTINGS FRAME ---
settingsframe = CreateFrame("Frame", "Settings", igtframe, "SimplePanelTemplate")
settingsframe:SetPoint("TOPLEFT", igtframe, "TOPRIGHT", -1,0)
settingsframe:SetSize(300, 640)
--  settingsframe:SetFrameStrata("TOOLTIP")
tinsert(UISpecialFrames, "Settings")

settingsframe.title = settingsframe:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
settingsframe.title:SetPoint("CENTER", settingsframe, "TOP", 0,-17)
settingsframe.title:SetText("Settings")
                
local mmcb = CreateFrame("checkbutton","MinimapButton", settingsframe, "UICheckButtonTemplate")
mmcb:SetPoint("TOPLEFT", settingsframe, "TOPLEFT", 6, -30)
if self.db.profile.minimap.hide then
    mmcb:SetChecked(false)
else
    mmcb:SetChecked(true)
end
mmcb:SetScript("OnClick", function(self, button, down) 

    if mmcb:GetChecked() then
        mmcb:SetChecked(true)
        MyAddon:CommandTheBunnies()
    else
        mmcb:SetChecked(false)
        MyAddon:CommandTheBunnies()
    end
    settingsframe:Hide()
    settingsframe:Show()
end)
mmcb:SetText("Minimap Button")
settingsframe.helpLabel = settingsframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
settingsframe.helpLabel:SetPoint("TOPLEFT", mmcb, "TOPRIGHT", 0, -9)
settingsframe.helpLabel:SetText("Minimap Button")

local lgcb = CreateFrame("checkbutton","LiveGoldButton", settingsframe, "UICheckButtonTemplate")
lgcb:SetPoint("TOPLEFT", mmcb, "TOPLEFT", 0 , -25)
if LiveGold == "ON" then
    lgcb:SetChecked(true)
else
    lgcb:SetChecked(false)
end
lgcb:SetScript("OnClick", function(self, button, down) 

    if lgcb:GetChecked() then
        lgcb:SetChecked(true)
        LiveGold = "ON"
    else
        lgcb:SetChecked(false)
        LiveGold = "OFF"
    end
    settingsframe:Hide()
    settingsframe:Show()
end)
settingsframe.helpLabel = settingsframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
settingsframe.helpLabel:SetPoint("TOPLEFT", lgcb, "TOPRIGHT", 0, -9)
settingsframe.helpLabel:SetText("Live Gold")


local editboxtime = CreateFrame("EditBox", "myboxtime", settingsframe, "InputBoxTemplate")
editboxtime:SetPoint("TOPLEFT", lgcb, "TOPLEFT", 10 , -25)
editboxtime:SetSize(32,32)
editboxtime:SetMaxLetters(4)
editboxtime:SetNumeric(true)
editboxtime:SetAutoFocus(false)
editboxtime:SetText(MinTime)
editboxtime:SetScript("OnCursorChanged", function() 
    MinTime = editboxtime:GetNumber()
end)



settingsframe.helpLabel = settingsframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
settingsframe.helpLabel:SetPoint("TOPLEFT", editboxtime, "TOPRIGHT", 3, -9)
settingsframe.helpLabel:SetText("Time: Below this, data wont be stored")

local editboxgold = CreateFrame("EditBox", "myboxgold", settingsframe, "InputBoxTemplate")
editboxgold:SetPoint("TOPLEFT", editboxtime, "TOPLEFT", 0 , -25)
editboxgold:SetSize(32,32)
editboxgold:SetMaxLetters(4)
editboxgold:SetNumeric(true)
editboxgold:SetAutoFocus(false)
editboxgold:SetText(MinGold)
editboxgold:SetScript("OnCursorChanged", function() 
    MinGold = editboxgold:GetNumber()
end)
editboxgold.tooltipText = "Delete selected entry"

settingsframe.helpLabel = settingsframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
settingsframe.helpLabel:SetPoint("TOPLEFT", editboxgold, "TOPRIGHT", 3, -9)
settingsframe.helpLabel:SetText("Gold: Below this, data wont be stored")

local deleteday = CreateFrame("EditBox", "mydeletebox", settingsframe, "InputBoxTemplate")
deleteday:SetPoint("TOPLEFT", editboxgold, "TOPLEFT", 0 , -25)
deleteday:SetSize(32,32)
deleteday:SetMaxLetters(4)
deleteday:SetNumeric(true)
deleteday:SetAutoFocus(false)
deleteday:SetText("")
deleteday.tooltipText = "Delete selected entry"

local deleteAll = CreateFrame("button","DeleteButton", settingsframe, "UIPanelButtonTemplate")
deleteAll:SetPoint("TOPLEFT", deleteday, "TOPRIGHT", 3, -5)
deleteAll:SetScript("OnClick", function(self, button, down) 
    if deleteday:GetText() ~= "" then
        for index = table.getn(table_Date), 1, -1 do
            returnedate, entrydate = datestuff(table_Date[index], deleteday:GetNumber()-1)
            if returnedate > entrydate then
                table.remove(table_Dungeon_Name, index)
                table.remove(table_Dungeon_Difficulty, index)
                table.remove(table_Time, index)
                table.remove(table_Looted_Item_Value_Total, index)
                table.remove(table_Looted_Money_Total, index)
                table.remove(table_Money_Total, index)
                table.remove(table_Character_Name, index)
                table.remove(table_Character_Class, index)
                table.remove(table_Item_Level, index)
                table.remove(table_Date, index)        
                table.remove(table_LootedItems, index)
                table.remove(table_LootedItemsQuantity, index)
            end
    
        end
    end
    dngframe:Hide()
    setTableData(0)
    st:ClearSelection()
end)
deleteAll:SetSize(239, 21)
deleteAll:SetText("Delete Data older than x day(s)")
deleteAll.tooltipText = "|cffff0000Data cant be restored...\n\n|cffffffff0 .. Delete All\n"

local PriceSourceButton = CreateFrame("button","PriceSourceButton", settingsframe, "UIPanelButtonTemplate")
PriceSourceButton:SetPoint("TOPLEFT", deleteday, "TOPLEFT", -7 , -30)
PriceSourceButton:SetText("Custom Price Source")
PriceSourceButton:SetSize(281, 21)
PriceSourceButton.tooltipText = "Current Price Source\n"..CustomPrice
if (IsAddOnLoaded("TradeSkillMaster")) then
    PriceSourceButton:Enable()
--    PriceSourceButton:Disable()
    PriceSourceButton:SetText("Custom Price Source")
else
    PriceSourceButton:Disable()
    PriceSourceButton:SetText("TradeSkillMaster not found")
end
PriceSourceButton:SetScript("OnClick", function(self, button, down)
    psf:SetShown(not psf:IsShown())
end)

local csvexport = CreateFrame("button","csvexport", settingsframe, "UIPanelButtonTemplate")
csvexport:SetPoint("TOPLEFT", PriceSourceButton, "BOTTOMLEFT", 0 , -4)
csvexport:SetText("Excel String: Runs")
csvexport:SetSize(281, 21)
csvexport:SetScript("OnClick", function(self, button, down)
    exportstring = "Instance".. "\t" .. "Difficulty" .. "\t" .. "Time" .. "\t" .. "Item Value" .. "\t" .. "Looted Money" .. "\t" .. "Total Money" .. "\t" .. "Character" .. "\n" 
    for i = 1, table.getn(table_Dungeon_Name) do
        temp = table_Dungeon_Name[i] .. "\t" .. table_Dungeon_Difficulty[i] .. "\t" .. table_Time[i]/86400 .. "\t" .. table_Looted_Item_Value_Total[i]/10000 .. "\t" .. table_Looted_Money_Total[i]/10000 .. "\t" .. table_Money_Total[i]/10000 .. "\t" .. table_Character_Name[i] .. "\n"
        temp = string.gsub(temp, '%.', ',')
        exportstring = exportstring .. temp
    end
    editBox:SetText(exportstring)
    exf:SetShown(not exf:IsShown())
end)

local csvexportlong = CreateFrame("button","csvexportlong", settingsframe, "UIPanelButtonTemplate")

csvexportlong:SetPoint("TOPLEFT", csvexport, "BOTTOMLEFT", 0 , -4)
csvexportlong:SetText("Excel String: Item List")
csvexportlong.tooltipText = "Select farm to create itemlist.\n\n|cFFFF0000This might take a few seconds!\n"
csvexportlong:SetSize(281, 21)
csvexportlong:SetScript("OnClick", function(self, button, down)
    PleaseTryAgain = 0
    table_start = {}
    table_mid = {}
    table_end = {}
    temp = {}
    if Dungeon_Name then
        exportstring = "Instance".. "\t" .. "Runs" .. "\t" .. "Item" .. "\t" .. "Item Qty." .. "\t" .. "Item Value[Gold]" .. "\t" .. "Avg. drops per Run".. "\t" .. "Price Source" .."\t" .. "wowhead.com" .. "\n" 
        for i = 1, table.getn(table_LootedItems) do
            dngtime, dngmoney, dnggold, dngitemvalue, dngcount, timearray, moneyarray = getpart(table_Dungeon_Name[i])
            if table_Dungeon_Name[i] == Dungeon_Name then
                for x = 1, table.getn(table_LootedItems[i]) do
                    itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(table_LootedItems[i][x])
                    if itemLink then
                        if TSM_API.GetCustomPriceValue(CustomPrice, "i:"..string.match(itemLink, "item:(%d*)")) and CustomPrice ~= "vendorsell" and (itemRarity > 1 or itemType == "Tradeskill" or itemType == "Quest") then
                            --  temp = table_Dungeon_Name[i] .. "\t" .. dngcount .. "\t" .. table_LootedItems[i][x] .. "\t" .. table_LootedItemsQuantity[i][x] .. "\t" .. itemSellPrice/10000 .. "\t".. table_LootedItemsQuantity[i][x]/dngcount .. "\t" .. "Vendorsell" .. "\t" .. "https://www#wowhead#com/item=" .. string.match(itemLink, "item:(%d*)") .. "\n"
                            if has_value(table_start, table_Dungeon_Name[i] .. "\t" .. dngcount .. "\t" .. table_LootedItems[i][x]) then
                                for y = 1, table.getn(table_start) do
                                    if table_start[y] == table_Dungeon_Name[i] .. "\t" .. dngcount .. "\t" .. table_LootedItems[i][x] then
                                        table_mid[y] = table_mid[y] +  table_LootedItemsQuantity[i][x]
                                        table_end[y] = TSM_API.GetCustomPriceValue(CustomPrice, "i:"..string.match(table_LootedItems[i][x], "item:(%d*)"))/10000 .. "\t".. table_mid[y]/dngcount .. "\t" .. CustomPrice .. "\t" .. "https://www#wowhead#com/item=" .. string.match(itemLink, "item:(%d*)") .. "\n"
                                    end
                                end
                            else
                                table.insert(table_start, table_Dungeon_Name[i] .. "\t" .. dngcount .. "\t" .. table_LootedItems[i][x])
                                table.insert(table_mid, table_LootedItemsQuantity[i][x])
                                table.insert(table_end, TSM_API.GetCustomPriceValue(CustomPrice, "i:"..string.match(table_LootedItems[i][x], "item:(%d*)"))/10000 .. "\t".. table_LootedItemsQuantity[i][x]/dngcount .. "\t" .. CustomPrice .. "\t" .. "https://www#wowhead#com/item=" .. string.match(itemLink, "item:(%d*)") .. "\n")
                            end
                        else
                            --  temp = table_Dungeon_Name[i] .. "\t" .. dngcount .. "\t" .. table_LootedItems[i][x] .. "\t" .. table_LootedItemsQuantity[i][x] .. "\t" .. itemSellPrice/10000 .. "\t".. table_LootedItemsQuantity[i][x]/dngcount .. "\t" .. "Vendorsell" .. "\t" .. "https://www#wowhead#com/item=" .. string.match(itemLink, "item:(%d*)") .. "\n"
                            if has_value(table_start, table_Dungeon_Name[i] .. "\t" .. dngcount .. "\t" .. table_LootedItems[i][x]) then
                                for y = 1, table.getn(table_start) do
                                    if table_start[y] == table_Dungeon_Name[i] .. "\t" .. dngcount .. "\t" .. table_LootedItems[i][x] then
                                        table_mid[y] = table_mid[y] +  table_LootedItemsQuantity[i][x]
                                        table_end[y] = itemSellPrice/10000 .. "\t".. table_mid[y]/dngcount .. "\t" .. "Vendorsell" .. "\t" .. "https://www#wowhead#com/item=" .. string.match(itemLink, "item:(%d*)") .. "\n"
                                    end
                                end
                            else
                                table.insert(table_start, table_Dungeon_Name[i] .. "\t" .. dngcount .. "\t" .. table_LootedItems[i][x])
                                table.insert(table_mid, table_LootedItemsQuantity[i][x])
                                table.insert(table_end, itemSellPrice/10000 .. "\t".. table_LootedItemsQuantity[i][x]/dngcount .. "\t" .. "Vendorsell" .. "\t" .. "https://www#wowhead#com/item=" .. string.match(itemLink, "item:(%d*)") .. "\n")
                            end
                        end
                    else
                        itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(table_LootedItems[i][x])
                        PleaseTryAgain = 1
                    end
                end
            end
        end
        for x = 1, table.getn(table_start) do
            table.insert(temp, table_start[x] .. "\t" .. table_mid[x] .. "\t" .. table_end[x])
        end
        for i = 1, table.getn(temp) do
            temp[i] = string.gsub(temp[i], '%.', ',')
            temp[i] = string.gsub(temp[i], '%#', '%.')
            exportstring = exportstring .. temp[i]
        end
        editBox:SetText(exportstring)
        if PleaseTryAgain == 1 then
            MyAddon:Print("|cFFFF0000Failed to create itemlist, please try again")
        else
            exf:Show()
        end
    else
        MyAddon:Print("Please select Instance or Farm first to create itemlist.")
    end
    
end)

local CustomFarmButton = CreateFrame("button","customfarm", settingsframe, "UIPanelButtonTemplate")
CustomFarmButton:SetPoint("TOPLEFT", csvexportlong, "BOTTOMLEFT", 0 , -4)
CustomFarmButton:SetText("Custom/Open World Farm")
CustomFarmButton:SetSize(281, 21)
CustomFarmButton:SetScript("OnClick", function(self, button, down)
    customframe:SetShown(not customframe:IsShown())
    tt_start = GetTime()
    tt_pause = 0
end)

local aexitusbuttontest = CreateFrame("button","customfarm", settingsframe, "UIPanelButtonTemplate")
aexitusbuttontest:SetPoint("TOPLEFT", CustomFarmButton, "BOTTOMLEFT", 0 , -4)
aexitusbuttontest:SetText("Æxitus Discord String")
aexitusbuttontest:SetSize(281, 21)
aexitusbuttontest.tooltipText = "Use this string to feed the Æxitus Discord your precious data."
aexitusbuttontest:Hide()
aexitusbuttontest:SetScript("OnClick", function(self, button, down)
    exportstring = "!postRun " .. table_Dungeon_Name[1] .. "\n"
    exportstring = exportstring .. "Klasse: " .. "Priest" .. "\n"
    exportstring = exportstring .. "Zeit: " .. SecondsToClock(table_Time[1]) .. "\n"
    exportstring = exportstring .. "Getötete Gegner: " .. "null" .. "\n"
    exportstring = exportstring .. "|cff1eff00Ungewöhnlich: " .. "|cffffffffnull" .. "\n"
    exportstring = exportstring .. "|cff0070ddSelten: " .. "|cffffffffnull" .. "\n"
    exportstring = exportstring .. "|cffa335eeEpisch: " .. "|cffffffffnull" .. "\n"
    exportstring = exportstring .. "LIV: " .. table_Looted_Item_Value_Total[1]/10000 .. "\n"
    exportstring = exportstring .. "Gold gelooted: " .. table_Looted_Money_Total[1]/10000 .. "\n"
    exportstring = exportstring .. "Gold gesamt: " .. table_Money_Total[1]/10000 .. "\n"
    exportstring = exportstring .. "Runs: " .. 1 .. "\n"
    exportstring = exportstring .. "Anmerkungen: " .. "Test" .. "\n"
    exf:SetWidth(300)
    exf:SetHeight(250)
    editBox:SetText(exportstring)
    exf:SetShown(not exf:IsShown())
end)


exf = CreateFrame("Frame", "ExcelFrame", UIParent, "SimplePanelTemplate")
exf:SetWidth(500)
exf:SetHeight(400)
exf:SetPoint("CENTER", UIParent, "CENTER")
exf:Hide()
exf:SetFrameStrata("DIALOG")
exf.title = exf:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
exf.title:SetPoint("CENTER", exf, "TOP", 0,-17)
exf.title:SetText("")
tinsert(UISpecialFrames, "ExcelFrame")

ButtonFrameTemplate_HideButtonBar(exf)
scrollArea = CreateFrame("ScrollFrame", "BCMCopyScroll", exf, "UIPanelScrollFrameTemplate")
scrollArea:SetPoint("TOPLEFT", exf, "TOPLEFT", 8, -30)
scrollArea:SetPoint("BOTTOMRIGHT", exf, "BOTTOMRIGHT", -30, 8)
exf:SetMovable(true)
exf:EnableMouse(true)
exf:RegisterForDrag("LeftButton")
exf:SetScript("OnDragStart", aexitusbuttontest.StartMoving)
exf:SetScript("OnDragStop", aexitusbuttontest.StopMovingOrSizing)

editBox = CreateFrame("EditBox", "BCMCopyBox", exf)
editBox:SetMultiLine(true)
editBox:EnableMouse(true)
editBox:SetAutoFocus(false)
editBox:SetFontObject(ChatFontNormal)
editBox:SetWidth(470)
editBox:SetHeight(270)
--editBox:SetScript("OnEscapePressed", function() exf:Hide() end)

scrollArea:SetScrollChild(editBox)

local close = CreateFrame("Button", "BCMCloseButton", exf, "UIPanelCloseButton")
close:SetPoint("TOPRIGHT", exf, "TOPRIGHT")


psf = CreateFrame("Frame", "PriceSourceFrame", UIParent, "SimplePanelTemplate")
psf:SetPoint("CENTER")
psf:SetSize(550, 167)
psf:SetFrameStrata("HIGH")
psf:EnableMouse(true)
tinsert(UISpecialFrames, "PriceSourceFrame")

psf.title = psf:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
psf.title:SetPoint("CENTER", psf, "TOP", 0,-17)
psf.title:SetText("Custom Price Source")
--ButtonFrameTemplate_HideButtonBar(psf) 

local button = CreateFrame("button","ExitButton", psf, "UIPanelCloseButtonNoScripts")
button:SetPoint("TOPRIGHT", psf, "TOPRIGHT", 0, -1)
button:SetScript("OnClick", function(self, button, down) self:GetParent():Hide() end)
---
local storage1 = CreateFrame("EditBox", "myboxgold", psf, "InputBoxTemplate")
storage1:SetPoint("TOPLEFT", psf, "TOPLEFT", 13 , -24)
storage1:SetSize(450,32)
storage1:SetAutoFocus(false)
storage1:SetText(CustomPriceStorage[1])
local savebtn = CreateFrame("button","SettingsButton", psf, "UIPanelButtonTemplate")
savebtn:SetPoint("TOPLEFT", storage1, "TOPRIGHT", -1, -6)
savebtn:SetSize(40, 21)
savebtn:SetText("Save")
savebtn:SetScript("OnClick", function(self, button, down)
    if TSM_API.GetCustomPriceValue(storage1:GetText(), "i:2589") then
        CustomPriceStorage[1] = storage1:GetText()
    else
        MyAddon:Print("|cFFFF0000Custom Price Source Invalid")
    end
end)
local usebtn = CreateFrame("button","SettingsButton", psf, "UIPanelButtonTemplate")
usebtn:SetPoint("TOPLEFT", savebtn, "TOPRIGHT", -1, 0)
usebtn:SetSize(40, 21)
usebtn:SetText("Use")
usebtn:SetScript("OnClick", function(self, button, down)
    if TSM_API.GetCustomPriceValue(storage1:GetText(), "i:2589") then
        CustomPrice = storage1:GetText()
        PriceSourceButton.tooltipText = "Current Price Source\n"..CustomPrice
        MyAddon:Print("Using TSM Price Source:", CustomPrice)
        recalculatetable()
        setTableData(0)
        CustomPriceStorage[1] = storage1:GetText()
    else
        MyAddon:Print("|cFFFF0000Custom Price Source Invalid")
    end
end)
---
local storage2 = CreateFrame("EditBox", "myboxgold", psf, "InputBoxTemplate")
storage2:SetPoint("TOPLEFT", storage1, "BOTTOMLEFT", 0 , 10)
storage2:SetSize(450,32)
storage2:SetAutoFocus(false)
storage2:SetText(CustomPriceStorage[2])
local savebtn = CreateFrame("button","SettingsButton", psf, "UIPanelButtonTemplate")
savebtn:SetPoint("TOPLEFT", storage2, "TOPRIGHT", -1, -6)
savebtn:SetSize(40, 21)
savebtn:SetText("Save")
savebtn:SetScript("OnClick", function(self, button, down)
    if TSM_API.GetCustomPriceValue(storage2:GetText(), "i:2589") then
        CustomPriceStorage[2] = storage2:GetText()
    else
        MyAddon:Print("|cFFFF0000Custom Price Source Invalid")
    end
end)
local usebtn = CreateFrame("button","SettingsButton", psf, "UIPanelButtonTemplate")
usebtn:SetPoint("TOPLEFT", savebtn, "TOPRIGHT", -1, 0)
usebtn:SetSize(40, 21)
usebtn:SetText("Use")
usebtn:SetScript("OnClick", function(self, button, down)
    if TSM_API.GetCustomPriceValue(storage2:GetText(), "i:2589") then
        CustomPrice = storage2:GetText()
        PriceSourceButton.tooltipText = "Current Price Source\n"..CustomPrice
        MyAddon:Print("Using TSM Price Source:", CustomPrice)
        recalculatetable()
        setTableData(0)
        CustomPriceStorage[2] = storage2:GetText()
    else
        MyAddon:Print("|cFFFF0000Custom Price Source Invalid")
    end
end)
---
local storage3 = CreateFrame("EditBox", "myboxgold", psf, "InputBoxTemplate")
storage3:SetPoint("TOPLEFT", storage2, "BOTTOMLEFT", 0 , 10)
storage3:SetSize(450,32)
storage3:SetAutoFocus(false)
storage3:SetText(CustomPriceStorage[3])
local savebtn = CreateFrame("button","SettingsButton", psf, "UIPanelButtonTemplate")
savebtn:SetPoint("TOPLEFT", storage3, "TOPRIGHT", -1, -6)
savebtn:SetSize(40, 21)
savebtn:SetText("Save")
savebtn:SetScript("OnClick", function(self, button, down)
    if TSM_API.GetCustomPriceValue(storage3:GetText(), "i:2589") then
        CustomPriceStorage[3] = storage3:GetText()
    else
        MyAddon:Print("|cFFFF0000Custom Price Source Invalid")
    end
end)
local usebtn = CreateFrame("button","SettingsButton", psf, "UIPanelButtonTemplate")
usebtn:SetPoint("TOPLEFT", savebtn, "TOPRIGHT", -1, 0)
usebtn:SetSize(40, 21)
usebtn:SetText("Use")
usebtn:SetScript("OnClick", function(self, button, down)
    if TSM_API.GetCustomPriceValue(storage3:GetText(), "i:2589") then
        CustomPrice = storage3:GetText()
        PriceSourceButton.tooltipText = "Current Price Source\n"..CustomPrice
        MyAddon:Print("Using TSM Price Source:", CustomPrice)
        recalculatetable()
        setTableData(0)
        CustomPriceStorage[3] = storage3:GetText()
    else
        MyAddon:Print("|cFFFF0000Custom Price Source Invalid")
    end
end)
---
local storage4 = CreateFrame("EditBox", "myboxgold", psf, "InputBoxTemplate")
storage4:SetPoint("TOPLEFT", storage3, "BOTTOMLEFT", 0 , 10)
storage4:SetSize(450,32)
storage4:SetAutoFocus(false)
storage4:SetText(CustomPriceStorage[4])
local savebtn = CreateFrame("button","SettingsButton", psf, "UIPanelButtonTemplate")
savebtn:SetPoint("TOPLEFT", storage4, "TOPRIGHT", -1, -6)
savebtn:SetSize(40, 21)
savebtn:SetText("Save")
savebtn:SetScript("OnClick", function(self, button, down)
    if TSM_API.GetCustomPriceValue(storage4:GetText(), "i:2589") then
        CustomPriceStorage[4] = storage4:GetText()
    else
        MyAddon:Print("|cFFFF0000Custom Price Source Invalid")
    end
end)
local usebtn = CreateFrame("button","SettingsButton", psf, "UIPanelButtonTemplate")
usebtn:SetPoint("TOPLEFT", savebtn, "TOPRIGHT", -1, 0)
usebtn:SetSize(40, 21)
usebtn:SetText("Use")
usebtn:SetScript("OnClick", function(self, button, down)
    if TSM_API.GetCustomPriceValue(storage4:GetText(), "i:2589") then
        CustomPrice = storage4:GetText()
        PriceSourceButton.tooltipText = "Current Price Source\n"..CustomPrice
        MyAddon:Print("Using TSM Price Source:", CustomPrice)
        recalculatetable()
        setTableData(0)
        CustomPriceStorage[4] = storage4:GetText()
    else
        MyAddon:Print("|cFFFF0000Custom Price Source Invalid")
    end
end)
local storage5 = CreateFrame("EditBox", "myboxgold", psf, "InputBoxTemplate")
storage5:SetPoint("TOPLEFT", storage4, "BOTTOMLEFT", 0 , 10)
storage5:SetSize(450,32)
storage5:SetAutoFocus(false)
storage5:SetText(CustomPriceStorage[5])
local savebtn = CreateFrame("button","SettingsButton", psf, "UIPanelButtonTemplate")
savebtn:SetPoint("TOPLEFT", storage5, "TOPRIGHT", -1, -6)
savebtn:SetSize(40, 21)
savebtn:SetText("Save")
savebtn:SetScript("OnClick", function(self, button, down)
    if TSM_API.GetCustomPriceValue(storage5:GetText(), "i:2589") then
        CustomPriceStorage[5] = storage5:GetText()
    else
        MyAddon:Print("|cFFFF0000Custom Price Source Invalid")
    end
end)
local usebtn = CreateFrame("button","SettingsButton", psf, "UIPanelButtonTemplate")
usebtn:SetPoint("TOPLEFT", savebtn, "TOPRIGHT", -1, 0)
usebtn:SetSize(40, 21)
usebtn:SetText("Use")
usebtn:SetScript("OnClick", function(self, button, down)
    if TSM_API.GetCustomPriceValue(storage5:GetText(), "i:2589") then
        CustomPrice = storage5:GetText()
        PriceSourceButton.tooltipText = "Current Price Source\n"..CustomPrice
        MyAddon:Print("Using TSM Price Source:", CustomPrice)
        recalculatetable()
        setTableData(0)
        CustomPriceStorage[5] = storage5:GetText()
    else
        MyAddon:Print("|cFFFF0000Custom Price Source Invalid")
    end
end)

local infobtn = CreateFrame("button","SettingsButton", psf, "UIPanelButtonTemplate")
infobtn:SetPoint("BOTTOMRIGHT", psf, "BOTTOMRIGHT", -7, 4)
infobtn:SetSize(80, 21)
infobtn:SetText("Info")
infobtn.tooltipText = "|cff9d9d9dPoor|cffffffff quality items will always use vendor sell values.\n\nCommon quality items except Trade Goods will use vendor sell.\n\n|cff1eff00Uncommon|cffffffff, |cff0070ddRare|cffffffff, and |cffa335eeEpic|cffffffff BoP items will use Blizzard vendor sell values."



--- CREATE GOLD FRAME ---
goldframe = CreateFrame("Frame", "GoldFrame", UIParent, "InsetFrameTemplate")
goldframe:SetPoint(goldframealign1, UIParent, goldframealign2, goldframex, goldframey)
goldframe:SetSize(150, 40)
goldframe:SetFrameStrata("TOOLTIP")

goldframe:SetMovable(true)
goldframe:EnableMouse(true)
goldframe:RegisterForDrag("LeftButton")
goldframe:SetScript("OnDragStart", goldframe.StartMoving)
goldframe:SetScript("OnDragStop", goldframe.StopMovingOrSizing)


goldframe.goldlabel = goldframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
goldframe.goldlabel:SetPoint("TOPLEFT", goldframe, "TOPLEFT", 8, -7)
goldframe.goldlabel:SetText("Gold:")

goldframe.goldlabel1 = goldframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
goldframe.goldlabel1:SetPoint("TOPRIGHT", goldframe, "TOPRIGHT", -8, -7)
goldframe.goldlabel1:SetText(CopperToGold(0))

goldframe.timerlbl1 = goldframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
goldframe.timerlbl1:SetPoint("TOPLEFT", goldframe.goldlabel, "TOPLEFT", 0, -15)
goldframe.timerlbl1:SetText("Timer:")

goldframe.timerlbl = goldframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
goldframe.timerlbl:SetPoint("LEFT", goldframe.goldlabel1, "RIGHT", -58, -15)

goldframe:SetScript("OnUpdate", function(event, elapsed)
    goldframe.timerlbl:SetText(SecondsToClock(math.floor(GetTime() - t_start)))
end)

goldframe:Hide()


--- Create Custom Frame
customframe = CreateFrame("Frame", "CustomFarmFrame", UIParent, "InsetFrameTemplate")
customframe:SetPoint(customframealign1, UIParent, customframealign2, customframex, customframey)
customframe:SetSize(150, 95)
customframe:SetFrameStrata("HIGH")
customframe:EnableMouse(true)
intgoldvalue = 0
intlootvalue = 0
inttotalvalue = 0
goldtemp = 0
templooted = 0
customframe.title = customframe:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
customframe.title:SetPoint("CENTER", customframe, "TOP", 0,-15)
--ButtonFrameTemplate_HideButtonBar(psf) 
customframe:Hide()

local resetbtn = CreateFrame("button","resetbutton", customframe, "UIPanelButtonTemplate")
resetbtn:SetPoint("BOTTOMLEFT", customframe, "BOTTOMLEFT", 5, 5)
resetbtn:SetSize(70, 21)
resetbtn:SetText("Reset")
resetbtn:SetScript("OnClick", function(self, button, down)
    tt_start = GetTime()
    tt_pause = 0
    intgoldvalue = 0
    intlootvalue = 0
    inttotalvalue = 0
    goldtemp = 0
    templooted = 0
    customframe.goldvalue1:SetText(CopperToGold(0))
    customframe.lootvalue1:SetText(CopperToGold(0))
    customframe.totalvalue1:SetText(CopperToGold(0))
    CustomLootedItems = {}
    CustomLootedItemsQuantity = {}
end)

local savebtn = CreateFrame("button","savebutton", customframe, "UIPanelButtonTemplate")
savebtn:SetPoint("BOTTOMRIGHT", customframe, "BOTTOMRIGHT", -5, 5)
savebtn:SetSize(70, 21)
savebtn:SetText("Save")
savebtn:SetScript("OnClick", function(self, button, down)
    saveframe:SetShown(not saveframe:IsShown())
    if currentlocation1 ~= ""then
        savebox:SetText(currentlocation .. " - " .. currentlocation1)
    else
        savebox:SetText(currentlocation)
    end
end)
--[[
local pausebtn = CreateFrame("button","pausebutton", customframe, "UIPanelButtonTemplate")
pausebtn:SetPoint("BOTTOMLEFT", customframe, "BOTTOMLEFT", 5, 5)
pausebtn:SetSize(70, 21)
pausebtn:SetText("Pause")
pausebtn:SetScript("OnClick", function(self, button, down)
    if pause == 1 then
        pause = 0
        pausebtn:SetText("Pause")
        MyAddon:Print("Continue")
        tt_start = GetTime() - tt_pause
    elseif pause == 0 then
        MyAddon:Print("Pause")
        pause = 1
        pausebtn:SetText("Continue")
        tt_pause = math.floor(GetTime() - tt_start)
        tt_start = GetTime() - tt_pause
    end
end)
]]

customframe:SetMovable(true)
customframe:EnableMouse(true)
customframe:RegisterForDrag("LeftButton")
customframe:SetScript("OnDragStart", customframe.StartMoving)
customframe:SetScript("OnDragStop", customframe.StopMovingOrSizing)

--local close = CreateFrame("Button", "BCMCloseButton", customframe, "UIPanelCloseButton")
--close:SetPoint("TOPRIGHT", customframe, "TOPRIGHT")


customframe.goldvalue = customframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
customframe.goldvalue:SetPoint("TOPLEFT", customframe, "TOPLEFT", 8, -7)
customframe.goldvalue:SetText("Gold:")

customframe.goldvalue1 = customframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
customframe.goldvalue1:SetPoint("TOPRIGHT", customframe, "TOPRIGHT", -8, -7)
customframe.goldvalue1:SetText(CopperToGold(0))

customframe.lootvalue = customframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
customframe.lootvalue:SetPoint("TOPLEFT", customframe.goldvalue, "TOPLEFT", 0, -15)
customframe.lootvalue:SetText("Loot:")

customframe.lootvalue1 = customframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
customframe.lootvalue1:SetPoint("RIGHT", customframe.goldvalue1, "RIGHT", 0, -15)
customframe.lootvalue1:SetText(CopperToGold(0))

customframe.totalvalue = customframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
customframe.totalvalue:SetPoint("TOPLEFT", customframe.lootvalue, "TOPLEFT", 0, -15)
customframe.totalvalue:SetText("Total:")

customframe.totalvalue1 = customframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
customframe.totalvalue1:SetPoint("RIGHT", customframe.lootvalue1, "RIGHT", 0, -15)
customframe.totalvalue1:SetText(CopperToGold(0))

customframe.timerlbl1 = customframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
customframe.timerlbl1:SetPoint("TOPLEFT", customframe.totalvalue, "TOPLEFT", 0, -15)
customframe.timerlbl1:SetText("Timer:")

customframe.timerlbl = customframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
customframe.timerlbl:SetPoint("LEFT", customframe.totalvalue1, "RIGHT", -58, -15)

customframe:SetScript("OnUpdate", function(event, elapsed)
    customframe.timerlbl:SetText(SecondsToClock(math.floor(GetTime() - tt_start)))
    customframealign1, temp, customframealign2, customframex, customframey = customframe:GetPoint()
end)

saveframe = CreateFrame("Frame", "Saveframe", UIParent, "InsetFrameTemplate")
saveframe:SetPoint("CENTER")
saveframe:SetSize(350, 20)
saveframe:SetFrameStrata("TOOLTIP")
saveframe:EnableMouse(true)

saveframe:SetMovable(true)
saveframe:EnableMouse(true)
saveframe:RegisterForDrag("LeftButton")
saveframe:SetScript("OnDragStart", customframe.StartMoving)
saveframe:SetScript("OnDragStop", customframe.StopMovingOrSizing)
tinsert(UISpecialFrames, "Saveframe")

local savebtn = CreateFrame("button","savebutton", saveframe, "UIPanelButtonTemplate")
savebtn:SetPoint("BOTTOMRIGHT", saveframe, "BOTTOMRIGHT", 0, 0)
savebtn:SetSize(70, 21)
savebtn:SetText("Save")

savebtn:SetScript("OnClick", function(self, button, down)
    tt_end = GetTime() - tt_start
    table.insert(table_Dungeon_Name,savebox:GetText())
    table.insert(table_Dungeon_Difficulty,"Custom")
    table.insert(table_Time,math.floor(tt_end))
    table.insert(table_Looted_Item_Value_Total,templooted)
    table.insert(table_Looted_Money_Total,goldtemp)
    table.insert(table_Money_Total,goldtemp + templooted)
    table.insert(table_Character_Name, player_name)
    table.insert(table_Item_Level, math.floor(0))
    table.insert(table_Character_Class, englishClass)
    table.insert(table_Date,date("%m/%d/%y"))
    table.insert(table_LootedItems, CustomLootedItems)
    table.insert(table_LootedItemsQuantity, CustomLootedItemsQuantity)
    saveframe:SetShown(not saveframe:IsShown())

    intgoldvalue = 0
    intlootvalue = 0
    inttotalvalue = 0
    goldtemp = 0
    templooted = 0
    customframe.goldvalue1:SetText(CopperToGold(0))
    customframe.lootvalue1:SetText(CopperToGold(0))
    customframe.totalvalue1:SetText(CopperToGold(0))
    CustomLootedItems = {}
    CustomLootedItemsQuantity = {}
    tt_start = GetTime()
    tt_pause = 0
end)

local savebox = CreateFrame("EditBox", "savebox", saveframe, "InputBoxTemplate")
savebox:SetPoint("BOTTOMLEFT", saveframe, "BOTTOMLEFT", 6 , 0)
savebox:SetSize(273,21)
savebox:SetAutoFocus(false)
savebox:SetText(MinTime)

--- SCROLLING TABLE ---
local ScrollingTable = LibStub("ScrollingTable");
local color = { 
    ["r"] = 0.5,
    ["g"] = 0.5,
    ["b"] = 1.0,
    ["a"] = 1.0,
};
local bgcolor = { 
    ["r"] = 0.0,
    ["g"] = 0.0,
    ["b"] = 0.0,
    ["a"] = 0.0,
};
local highlight = { 
    ["r"] = 0.75,
    ["g"] = 0.75,
    ["b"] = 0.75,
    ["a"] = 0.1,
};

local cols = {
    {
        ["name"] = "Name",
        ["width"] = 200,
        ["align"] = "LEFT",
        ["color"] = color,
        ["highlight"] = highlight,
        ["bgcolor"] = bgcolor,
        ["defaultsort"] = "dsc",
        ["sortnext"] = 2,
    },
    {
        ["name"] = "Difficulty",
        ["width"] = 100,
        ["align"] = "LEFT",
        ["highlight"] = highlight,
        ["bgcolor"] = bgcolor,
        ["defaultsort"] = "dsc",
        ["sortnext"] = 3,
        ["comparesort"] = function (st, rowa, rowb, col)
            vala = 0 
            valb = 0
            if string.sub(st.data[rowa].cols[col].value, 1, 1) == "R" then
                for word in string.gmatch(st.data[rowa].cols[col].value, "%S+") do
                    if tonumber(word) then
                        vala = tonumber(word)
                    end
                end
                for word in string.gmatch(st.data[rowb].cols[col].value, "%S+") do
                    if tonumber(word) then
                        valb = tonumber(word)
                    end                
                end
                if sortdirection then
                    return vala < valb
                else
                    return vala > valb
                end
            else
                if sortdirection then
                    return st.data[rowa].cols[col].value < st.data[rowb].cols[col].value
                else
                    return st.data[rowa].cols[col].value > st.data[rowb].cols[col].value
                end
            end
        end,        
    },
    {
        ["name"] = "Time",
        ["width"] = 60,
        ["align"] = "CENTER",
        ["highlight"] = highlight,
        ["bgcolor"] = bgcolor,
        ["defaultsort"] = "dsc",
        
    },
    {
        ["name"] = "Item Value",
        ["width"] = 90,
        ["align"] = "CENTER",
        ["highlight"] = highlight,
        ["bgcolor"] = bgcolor,
        ["defaultsort"] = "dsc",
        ["comparesort"] = function (st, rowa, rowb, col)
            vala = 0 
            valb = 0
            for word in string.gmatch(string.sub(st.data[rowa].cols[col].value, 11, 100), "%S+") do
                if tonumber(word) then
                    vala = word
                end
            end
            for word in string.gmatch(string.sub(st.data[rowb].cols[col].value, 11, 100), "%S+") do
                if tonumber(word) then
                    valb = word
                end                
            end
            if sortdirection then
                return tonumber(vala) < tonumber(valb)
            else
                return tonumber(vala) > tonumber(valb)
            end            
        end,        
    },
    {
        ["name"] = "Gold",
        ["width"] = 90,
        ["align"] = "CENTER",
        ["highlight"] = highlight,
        ["bgcolor"] = bgcolor,
        ["defaultsort"] = "dsc",
        ["comparesort"] = function (st, rowa, rowb, col)
            vala = 0 
            valb = 0
            for word in string.gmatch(string.sub(st.data[rowa].cols[col].value, 11, 100), "%S+") do
                if tonumber(word) then
                    vala = word
                end
            end
            for word in string.gmatch(string.sub(st.data[rowb].cols[col].value, 11, 100), "%S+") do
                if tonumber(word) then
                    valb = word
                end                
            end
            if sortdirection then
                return tonumber(vala) < tonumber(valb)
            else
                return tonumber(vala) > tonumber(valb)
            end            
         end,        
    },
    {
        ["name"] = "Total",
        ["width"] = 90,
        ["align"] = "CENTER",
        ["highlight"] = highlight,
        ["bgcolor"] = bgcolor,
        ["defaultsort"] = "dsc",
        ["comparesort"] = function (st, rowa, rowb, col)
            vala = 0 
            valb = 0
            for word in string.gmatch(string.sub(st.data[rowa].cols[col].value, 11, 100), "%S+") do
                if tonumber(word) then
                    vala = word
                end
            end
            for word in string.gmatch(string.sub(st.data[rowb].cols[col].value, 11, 100), "%S+") do
                if tonumber(word) then
                    valb = word
                end                
            end
            if sortdirection then
                return tonumber(vala) < tonumber(valb)
            else
                return tonumber(vala) > tonumber(valb)
            end            
         end,        
    },
    {
        ["name"] = "Per Hour",
        ["width"] = 90,
        ["align"] = "CENTER",
        ["highlight"] = highlight,
        ["bgcolor"] = bgcolor,
        ["defaultsort"] = "dsc",
        ["comparesort"] = function (st, rowa, rowb, col)
            vala = 0 
            valb = 0
            for word in string.gmatch(string.sub(st.data[rowa].cols[col].value, 11, 100), "%S+") do
                if tonumber(word) then
                    vala = word
                end
            end
            for word in string.gmatch(string.sub(st.data[rowb].cols[col].value, 11, 100), "%S+") do
                if tonumber(word) then
                    valb = word
                end                
            end
            if sortdirection then
                return tonumber(vala) < tonumber(valb)
            else
                return tonumber(vala) > tonumber(valb)
            end            
         end,        
    },
    {
        ["name"] = "Character",
        ["width"] = 100,
        ["align"] = "CENTER",
        ["highlight"] = highlight,
        ["bgcolor"] = bgcolor,
        ["defaultsort"] = "dsc",
    },
    {
        ["name"] = "Date",
        ["width"] = 65,
        ["align"] = "CENTER",
        ["highlight"] = highlight,
        ["bgcolor"] = bgcolor,
        ["defaultsort"] = "dsc",
    },

};
st = ScrollingTable:CreateST(cols, 24, 23, nil, igtframe);
st.frame:SetPoint("CENTER", igtframe, "CENTER", -1,-10)
st:EnableSelection(true)

--- SCROLLING TABLE ITEMS ---
local ScrollingTable = LibStub("ScrollingTable");
local color = { 
    ["r"] = 0.5,
    ["g"] = 0.5,
    ["b"] = 1.0,
    ["a"] = 1.0,
};
local bgcolor = { 
    ["r"] = 0.0,
    ["g"] = 0.0,
    ["b"] = 0.0,
    ["a"] = 0.0,
};
local highlight = { 
    ["r"] = 0.75,
    ["g"] = 0.75,
    ["b"] = 0.75,
    ["a"] = 0.1,
};

local cols = {
    {
        ["name"] = "Item",
        ["width"] = 200,
        ["align"] = "LEFT",
        ["color"] = color,
        ["highlight"] = highlight,
        ["bgcolor"] = bgcolor,
        ["defaultsort"] = "dsc",
    },
    {
        ["name"] = " ",
        ["width"] = 52,
        ["align"] = "RIGHT",
        ["highlight"] = highlight,
        ["bgcolor"] = bgcolor,
        ["defaultsort"] = "dsc",
    },


};

st_items = ScrollingTable:CreateST(cols, 24, 23, nil, dngframe);
st_items.frame:SetPoint("CENTER", dngframe, "CENTER", -1,-10)

--- ON CLICK ---
st:RegisterEvents({
["OnClick"] = function (rowFrame, cellFrame, data, cols, row, realrow, column, scrollingTable, button, ...)
    if button == "LeftButton" and row then
        ihatemylife = 1
        if maintable == 0 then
            currentrow = realrow
            if currentrow == st:GetSelection() then
                dngframe:Hide()
            end
            if currentrow then
                currententry = currentrow
                setTableData(currentrow)
            end
           
           ihatemylife = 0

        else
            if realrow then
                dngframe:Show()
                setTableData2(getindexofentry(realrow))
            end
       
        end

    else
        sortdirection = not sortdirection
    end
    st:ClearSelection()
end,

["OnMouseUp"] = function (rowFrame, cellFrame, data, cols, row, realrow, column, scrollingTable, button, ...)
    --st:ClearSelection()
end,


});
st_items:RegisterEvents({
["OnClick"] = function (rowFrame, cellFrame, data, cols, row, realrow, column, scrollingTable, button, ...)
    if button == "LeftButton" and row then
        DressUpItemLink(data[realrow].cols[1].value)
    end
end,
});


--- TOOLTIP ---
st_items:RegisterEvents({
    ["OnEnter"] = function (rowFrame, cellFrame, data, cols, row, realrow, column, scrollingTable, ...)
        if st:GetSelection() and table_LootedItems[getindexofentry(st:GetSelection())][realrow] ~= "No items recorded." then
            if realrow then
                ItemTooltip:SetOwner(TargetFrame, "TOPLEFT")
                ItemTooltip:SetHyperlink(table_LootedItems[getindexofentry(st:GetSelection())][realrow])
                ItemTooltip:Show()
            end
        end
    end,

    ["OnLeave"] = function(realrow)
        ItemTooltip:Hide()
    end
});

--- TIMER ---
local function instance_timer()
    local localizedClass, englishClass, classIndex = UnitClass("player")
    local inInstance, instanceType = IsInInstance()
    local overall, equipped = GetAverageItemLevel()
    local name, type, difficultyIndex, difficultyName, maxPlayers,dynamicDifficulty, isDynamic, instanceMapId, lfgID = GetInstanceInfo()
    difficulty_lastDungen = difficultyName

    if inInstance and (instanceType == "party" or instanceType == "raid") then
        if timer_Status == 0 then
            timer_Status = 1
            sell_value_total = 0
            sell_value_per_minute = 0
            looted_money_total = 0
            looted_money_per_minute = 0
            total_money = 0
            total_money_per_minute = 0
            LootedItems = {}
            LootedItemsQuantity = {}

            if LiveGold == "ON" then
                goldframe:Show()
                goldframe.goldlabel1:SetText(CopperToGold(0))
               
            end
            
            name_lastDungen = name
            t_start = GetTime()
            MyAddon:Print("Your run is being recorded.")
        end
    else
        goldframealign1, temp, goldframealign2, goldframex, goldframey = goldframe:GetPoint()
        if timer_Status == 1 then
            timer_Status = 0
            t_end = GetTime() - t_start
            sell_value_per_minute = (sell_value_total / (math.floor(t_end*1000)/1000)) * 60
            total_money = sell_value_total + looted_money_total
            looted_money_per_minute = (looted_money_total / (math.floor(t_end*1000)/1000)) * 60
            total_money_per_minute = (total_money / (math.floor(t_end*1000)/1000)) * 60

            goldframe:Hide()

            if t_end >= MinTime and total_money >= MinGold  * 10000 then
                table.insert(table_Dungeon_Name,name_lastDungen)
                table.insert(table_Dungeon_Difficulty,difficultyName)
                table.insert(table_Time,math.floor(t_end))
                table.insert(table_Looted_Item_Value_Total,sell_value_total)
                table.insert(table_Looted_Money_Total,looted_money_total)
                table.insert(table_Money_Total,total_money)
                table.insert(table_Character_Name, player_name)
                table.insert(table_Item_Level, math.floor(equipped))
                table.insert(table_Character_Class, englishClass)
                table.insert(table_Date,date("%m/%d/%y"))
                table.insert(table_LootedItems, LootedItems)
                table.insert(table_LootedItemsQuantity, LootedItemsQuantity)
                dngtime, dngmoney, dnggold, dngitemvalue, dngcount, timearray, moneyarray = getpart(table_Dungeon_Name[table.getn(table_Dungeon_Name)])
                MyAddon:Print("Stored data:", name_lastDungen, difficultyName)
                MyAddon:Print("Gold earned:", CopperToGold(total_money))
                MyAddon:Print("Average run:", CopperToGold(math.floor(dngmoney/dngcount)))
            else
                MyAddon:Print("Time or Gold below your minimum. Data has not been stored.")
                MyAddon:Print("|cFFF9BB96 /igtsave |cFFFFFFFFto save data.")
            end
        end
    end
end

--- HANDLE LOOTED ITEMS ---
local function loot_item(arg1)
    local loottype, itemLink, quantity, source
    if arg1:match(PATTERN_LOOT_ITEM_SELF_MULTIPLE) then
        itemLink, quantity = smatch(arg1, PATTERN_LOOT_ITEM_SELF_MULTIPLE)
        itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink)
            if (IsAddOnLoaded("TradeSkillMaster")) then
                if TSM_API.GetCustomPriceValue(CustomPrice, "i:"..string.match(itemLink, "item:(%d*)")) and CustomPrice ~= "vendorsell" and (itemRarity > 1 or itemType == "Tradeskill") then
                    itemSellPrice = TSM_API.GetCustomPriceValue(CustomPrice, "i:"..string.match(itemLink, "item:(%d*)"))
                    sell_value_total = sell_value_total + (quantity * TSM_API.GetCustomPriceValue(CustomPrice, "i:"..string.match(itemLink, "item:(%d*)")))
                else
                    sell_value_total = sell_value_total + (quantity * itemSellPrice)
                end
            else
                sell_value_total = sell_value_total + (quantity * itemSellPrice)
            end
            templooted = templooted + quantity * itemSellPrice
    elseif arg1:match(PATTERN_LOOT_ITEM_SELF) then
        itemLink = smatch(arg1, PATTERN_LOOT_ITEM_SELF)
        itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink)
        quantity = 1
        if (IsAddOnLoaded("TradeSkillMaster")) then
            if TSM_API.GetCustomPriceValue(CustomPrice, "i:"..string.match(itemLink, "item:(%d*)")) and CustomPrice ~= "vendorsell" and (itemRarity > 1 or itemType == "Tradeskill") then
                itemSellPrice = TSM_API.GetCustomPriceValue(CustomPrice, "i:"..string.match(itemLink, "item:(%d*)"))
                sell_value_total = sell_value_total + TSM_API.GetCustomPriceValue(CustomPrice, "i:"..string.match(itemLink, "item:(%d*)"))
            else
                sell_value_total = sell_value_total + itemSellPrice
            end
        else
            sell_value_total = sell_value_total + itemSellPrice
        end
        templooted = templooted + itemSellPrice
    end

    if table.getn(LootedItems) == 0 then
        table.insert(LootedItems, itemLink)
        table.insert(LootedItemsQuantity, quantity)
    else
        saved = 0
        for i = 1, table.getn(LootedItems) do
            if LootedItems[i] == itemLink then
                LootedItemsQuantity[i] = LootedItemsQuantity[i] + quantity
                saved = 1
            end
        end
        if saved == 0 then
            table.insert(LootedItems, itemLink)
            table.insert(LootedItemsQuantity, quantity)
        end
    end
    if table.getn(CustomLootedItems) == 0 then
        table.insert(CustomLootedItems, itemLink)
        table.insert(CustomLootedItemsQuantity, quantity)
    else
        saved = 0
        for i = 1, table.getn(CustomLootedItems) do
            if CustomLootedItems[i] == itemLink then
                CustomLootedItemsQuantity[i] = CustomLootedItemsQuantity[i] + quantity
                saved = 1
            end
        end
        if saved == 0 then
            table.insert(CustomLootedItems, itemLink)
            table.insert(CustomLootedItemsQuantity, quantity)
        end
    end
end

--- HANDLE LOOTED GOLD ---
local function loot_money(arg1)
    local string_table = {}
    local gold, silver, copper = 0
    local is_gold, is_silver, is_copper = 0
    local digits = {}
    local digitsCounter = 0;

    if string.match(arg1, "+") then arg1 = string.sub(arg1, 1, string.find(arg1, "+")) end

    arg1:gsub("%d+",
        function(i)
            table.insert(digits, i)
            digitsCounter = digitsCounter + 1
        end
    )
    local copper = 0
        if digitsCounter == 3 then
            -- gold + silber + copper
            copper = (digits[1]*10000)+(digits[2]*100)+(digits[3])
        elseif digitsCounter == 2 then
            -- silber + copper
            copper = (digits[1]*100)+(digits[2])
        else
            -- copper
            copper = digits[1]
        end
        if string.match(arg1, "+") then copper = round(copper * 1.02) end
        looted_money_total = copper + looted_money_total
        goldtemp = goldtemp + copper
    end
---  EVENT HANDLER ---
local function myEventHandler(self, event, ...)
    local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15= ...

    if event == 'ZONE_CHANGED' then
        currentlocation = GetZoneText()
        currentlocation1 = GetSubZoneText()
        elseif event == 'ZONE_CHANGED_NEW_AREA' then
        currentlocation = GetZoneText()
        currentlocation1 = GetSubZoneText()
        elseif event == "CHAT_MSG_LOOT" then
        loot_item(arg1)

        goldframe.goldlabel1:SetText(CopperToGold(looted_money_total + sell_value_total))
        customframe.lootvalue1:SetText(CopperToGold(intlootvalue + templooted))
        customframe.totalvalue1:SetText(CopperToGold(inttotalvalue + goldtemp + templooted))
    elseif event == "CHAT_MSG_MONEY" then
        loot_money(arg1)
        goldframe.goldlabel1:SetText(CopperToGold(looted_money_total + sell_value_total))
        customframe.goldvalue1:SetText(CopperToGold(intgoldvalue + goldtemp))
        customframe.totalvalue1:SetText(CopperToGold(inttotalvalue + goldtemp + templooted))
    elseif event == 'PLAYER_ENTERING_WORLD' then
        instance_timer()
     end
    
end

--- SLASH COMMANDS ---
SLASH_OPENFRAME1 = "/igt"
SlashCmdList.OPENFRAME = function(arg)
    maintable = 1
    igtframe:SetShown(not igtframe:IsShown())
    dngframe:Hide()
    setTableData()
end

SLASH_MINIMAPHIDE1 = "/igticon"
SlashCmdList.MINIMAPHIDE = function(arg)
        mmcb:SetChecked(not mmcb:GetChecked())
    if self.db.profile.minimap.hide then
        icon:Show("Instance Gold Tracker")
    else
        icon:Hide("Instance Gold Tracker")
    end
        self.db.profile.minimap.hide = not self.db.profile.minimap.hide 
end

SLASH_TEST1 = "/igttest"
SlashCmdList.TEST = function(arg)
--    removeNoItems()
end

SLASH_CUSTOMFARM1 = "/igtcustom"
SlashCmdList.CUSTOMFARM = function(arg)
    tt_start = GetTime()
    tt_pause = 0
    customframe:SetShown(not customframe:IsShown())
end

SLASH_SAVE1 = "/igtsave"
SlashCmdList.SAVE = function(arg)
    if name_lastDungen then
        local overall, equipped = GetAverageItemLevel()
        table.insert(table_Dungeon_Name,name_lastDungen)
        table.insert(table_Dungeon_Difficulty,difficulty_lastDungen)
        table.insert(table_Time,math.floor(t_end))
        table.insert(table_Looted_Item_Value_Total,sell_value_total)
        table.insert(table_Looted_Money_Total,looted_money_total)
        table.insert(table_Money_Total,total_money)
        table.insert(table_Character_Name, player_name)
        table.insert(table_Item_Level, math.floor(equipped))
        table.insert(table_Character_Class, englishClass)
        table.insert(table_Date,date("%m/%d/%y"))
        table.insert(table_LootedItems, LootedItems)
        table.insert(table_LootedItemsQuantity, LootedItemsQuantity)
        dngtime, dngmoney, dnggold, dngitemvalue, dngcount, timearray, moneyarray = getpart(table_Dungeon_Name[table.getn(table_Dungeon_Name)])
        MyAddon:Print("Stored data:", name_lastDungen, difficulty_lastDungen)
        MyAddon:Print("Gold earned:", CopperToGold(total_money))
        MyAddon:Print("Average run:", CopperToGold(math.floor(dngmoney/dngcount)))
    end
end

--- REGISTER EVENTS ---
igtframe:RegisterEvent("ZONE_CHANGED")
igtframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")
igtframe:RegisterEvent("CHAT_MSG_LOOT")
igtframe:RegisterEvent("CHAT_MSG_MONEY")
igtframe:RegisterEvent("PLAYER_LOGIN")
igtframe:RegisterEvent("PLAYER_ENTERING_WORLD")
igtframe:SetScript("OnEvent", myEventHandler)
end

local f = CreateFrame("Frame")
f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f:SetScript("OnEvent", function(self, event)
	self:OnEvent(event, CombatLogGetCurrentEventInfo())
end)

function f:OnEvent(event, ...)
	local timestamp, subevent, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
	local spellId, spellName, spellSchool
	local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand
    if subevent == "PARTY_KILL" then
--	    MyAddon:Print("KILL")
	end
end



--- CONVERT SECONDS TO HOUR:MINUTES:SECONDS ---
function SecondsToClock(seconds)
    local seconds = tonumber(seconds)
    if seconds <= 0 then
        return "00:00:00";
    else
        hours = string.format("%02.f", math.floor(seconds/3600));
        mins = string.format("%02.f", math.floor(seconds/60 - (hours*60)));
        secs = string.format("%02.f", math.floor(seconds - hours*3600 - mins *60));
        return hours..":"..mins..":"..secs
    end
end

--- CONVERT COPPER TO GOLD SILVER COPPER ---
function CopperToGold(copper)
    gold = floor(copper / 10000)
    silver = string.sub(copper, string.len(copper)-3, string.len(copper)-2)
    copper = string.sub(copper, string.len(copper)-1, string.len(copper))
    return  "|cFFC9B037" .. gold .. " " .. "|cFF808080" .. silver .. " " .. "|cFF976D5C" .. copper
end

--- REMOVE ENTRY FROM TABLE ---
function deleteEntry(index)
    table.remove(table_Dungeon_Name, index)
    table.remove(table_Dungeon_Difficulty, index)
    table.remove(table_Time, index)
    table.remove(table_Looted_Item_Value_Total, index)
    table.remove(table_Looted_Money_Total, index)
    table.remove(table_Money_Total, index)
    table.remove(table_Character_Name, index)
    table.remove(table_Character_Class, index)
    table.remove(table_Item_Level, index)
    table.remove(table_Date, index)        
    table.remove(table_LootedItems, index)
    table.remove(table_LootedItemsQuantity, index)
end

--- SET MAIN TABLE DATA ---
function setTableData(realrow)
    st:EnableSelection(true)
    st:ClearSelection()
    data = {}
    if maintable == 1 or realrow == 0 then
        table_single_dungeon_name = {table_Dungeon_Name[1]}


        for x = 1, table.getn(table_Dungeon_Name) do
            for i = 1, table.getn(table_single_dungeon_name) do
                if has_value(table_single_dungeon_name, table_Dungeon_Name[x]) then
                else
                    table.insert(table_single_dungeon_name, table_Dungeon_Name[x])
                end
            end
        end

        table_single_character_name = {table_Character_Name[1]}


        for x = 1, table.getn(table_Character_Name) do
            for i = 1, table.getn(table_single_character_name) do
                if has_value(table_single_character_name, table_Character_Name[x]) then
                else
                    table.insert(table_single_character_name, table_Character_Name[x])
                end
            end
        end

        for row = 1, table.getn(table_single_dungeon_name) do
            if not data[row] then
                data[row] = {};
            end
            if not data[row].cols then
                data[row].cols = {};
            end
            dngtime, dngmoney, dnggold, dngitemvalue, dngcount, timearray, moneyarray = getpart(table_single_dungeon_name[row])
            data[row].cols[1] = { ["value"] = table_single_dungeon_name[row] .. "" } -- name
            data[row].cols[2] = { ["value"] = "Runs: " .. dngcount} -- difficulty
            data[row].cols[3] = { ["value"] = SecondsToClock(dngtime) } -- time
            data[row].cols[4] = { ["value"] = CopperToGold(dngitemvalue) } -- item value
            data[row].cols[5] = { ["value"] = CopperToGold(dnggold) } -- gold
            data[row].cols[6] = { ["value"] = CopperToGold(dngmoney) } -- total
            data[row].cols[7] = { ["value"] = CopperToGold(math.floor(3600/sumArray(timearray)*sumArray(moneyarray))) } -- per hour
            data[row].cols[8] = { ["value"] = "----------" } 
            data[row].cols[9] = { ["value"] = "----------" }
        end
        
        mainbtn:Hide()
        maintable = 0
    elseif maintable == 0 then
        row = 1
        Dungeon_Name = table_single_dungeon_name[realrow]
        for i = 1, table.getn(table_Dungeon_Name) do
            if table_Dungeon_Name[i] == table_single_dungeon_name[realrow] then
                if not data[row] then
                    data[row] = {};
                end
                if not data[row].cols then
                    data[row].cols = {};
                end
                data[row].cols[1] = { ["value"] = table_Dungeon_Name[i] }
                data[row].cols[2] = { ["value"] = table_Dungeon_Difficulty[i] }
                data[row].cols[3] = { ["value"] = SecondsToClock(table_Time[i]) }
                data[row].cols[4] = { ["value"] = CopperToGold(table_Looted_Item_Value_Total[i]) }
                data[row].cols[5] = { ["value"] = CopperToGold(table_Looted_Money_Total[i]) }
                data[row].cols[6] = { ["value"] = CopperToGold(table_Money_Total[i]) }
                data[row].cols[7] = { ["value"] = CopperToGold(3600/table_Time[i]*table_Money_Total[i]) }
                data[row].cols[8] = { ["value"] = table_Character_Name[i] }
                data[row].cols[9] = { ["value"] = table_Date[i] }
                row = row + 1
            end
        end
        mainbtn:Show()
        maintable = 1 
    end
    st:SetData(data)
    st:SortData()	
end

--- SET TABLE DATA ITEMS---
function setTableData2(realrow)
    local data = {}
        if table_LootedItems[realrow] then
            if table.getn(table_Dungeon_Name) >= realrow then
                for row = 1, table.getn(table_LootedItems[realrow]) do
                    if not data[row] then
                        data[row] = {};
                    end
                    if not data[row].cols then
                        data[row].cols = {};
                    end
                    data[row].cols[1] = { ["value"] = table_LootedItems[realrow][row] }
                    data[row].cols[2] = { ["value"] = table_LootedItemsQuantity[realrow][row] }
                end
            end
        end
    st_items:ClearSelection()
    st_items:SetData(data)
    st_items:SortData()
end

function SetNoItems()
    for i = 1, table.getn(table_Dungeon_Name) do
        if table_Character_Class[i] then
        else
            table.insert(table_Character_Class, "No Class")
        end
    end
end

function removeNoItems()
    for i = table.getn(table_LootedItems), 1 , -1 do
        if table_LootedItems[i][1] then
            if table_LootedItems[i][1] == "No items recorded." then
                table.remove(table_Dungeon_Name, i)
                table.remove(table_Dungeon_Difficulty, i)
                table.remove(table_Time, i)
                table.remove(table_Looted_Item_Value_Total, i)
                table.remove(table_Looted_Money_Total, i)
                table.remove(table_Money_Total, i)
                table.remove(table_Character_Name, i)
                table.remove(table_Character_Class, i)
                table.remove(table_Item_Level, i)
                table.remove(table_Date, i)
                table.remove(table_LootedItems, i)
                table.remove(table_LootedItemsQuantity, i)
            end
        end
    end
end

--- SUM ARRAY ---
function sumArray(thistable)
    something = 0
    for i = 1, table.getn(thistable) do
        something = something + thistable[i]  
    end
    return something
end

--- GET MIN FROM ARRAY ---
function minArray(thistable)
    something = thistable[1] 
    for i = 1, table.getn(thistable) do
        if something > thistable[i] then
            something = thistable[i] 
        end 
    end
    return something
end

--- GET MAX FROM ARRAY ---
function maxArray(thistable)
    something = thistable[1] 
    for i = 1, table.getn(thistable) do
        if something < thistable[i] then
            something = thistable[i] 
        end 
    end
    return something
end

--- GET TABLE PART ---
function getpart(name)
    runcount = 0
    temp_table_time = {}
    temp_table_money = {}
    temp_table_gold = {}
    temp_table_looted_item = {}
    for i = 1, table.getn(table_Dungeon_Name) do
        if table_Dungeon_Name[i] == name then
            table.insert(temp_table_time, table_Time[i])
            table.insert(temp_table_money, table_Money_Total[i])
            table.insert(temp_table_gold, table_Looted_Money_Total[i])
            table.insert(temp_table_looted_item, table_Looted_Item_Value_Total[i])
            
            runcount = runcount + 1
        end
    end


return sumArray(temp_table_time), sumArray(temp_table_money), sumArray(temp_table_gold), sumArray(temp_table_looted_item), runcount, temp_table_time, temp_table_money
end


--- GET INDEX OF ENTRY---
function getindexofentry(realrow)
    counter = 0
    local returnvalue = 0
    for i = 1, table.getn(table_Dungeon_Name) do
        if table_Dungeon_Name[i] == table_single_dungeon_name[currententry] then
            counter = counter + 1
        end
        if counter == realrow then
            returnvalue = i
            break
        end
    end
    return returnvalue
end


--- DATE STUFF ---
function datestuff(entrydate, days)

    today = date("%m/%d/%y")
    dates = {}
    dates1 = {}

    today:gsub("%d+",
    function(i)
        table.insert(dates, i)
    end
    )
    if entrydate then
        entrydate:gsub("%d+",
        function(i)
            table.insert(dates1, i)
        end
        )

        entrydate = time{month = dates1[1], day = dates1[2], year = "20" .. dates1[3]}
        returnedate = time{month = dates[1], day = dates[2] - days, year = "20" .. dates[3]}

        return returnedate, entrydate
    end
end

--- ROUND NUMBERS ---
function round(num, numDecimalPlaces)
    local mult = 10^(numDecimalPlaces or 0)
    return math.floor(num * mult + 0.5) / mult
end
--- UNUSED SOURCE CODE ---

function recalculatetable ()
    for i = 1, table.getn(table_Dungeon_Name) do
        temp = 0
        for x = 1, table.getn(table_LootedItems[i])do
            itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(table_LootedItems[i][x])
            if itemName then
                if (IsAddOnLoaded("TradeSkillMaster")) then
                    if TSM_API.GetCustomPriceValue(CustomPrice, "i:"..string.match(itemLink, "item:(%d*)")) and CustomPrice ~= "vendorsell" and (itemRarity > 1 or itemType == "Tradeskill") then
                        itemSellPrice = TSM_API.GetCustomPriceValue(CustomPrice, "i:"..string.match(itemLink, "item:(%d*)"))
                    end
                end
                temp = temp + (itemSellPrice * table_LootedItemsQuantity[i][x])
            end
        end
        table_Looted_Item_Value_Total[i] = temp
        table_Money_Total[i] = temp + table_Looted_Money_Total[i] 
    end
end

function instance_timers()
    local localizedClass, englishClass, classIndex = UnitClass("player")
    local inInstance, instanceType = IsInInstance()
    local overall, equipped = GetAverageItemLevel()
    local name, type, difficultyIndex, difficultyName, maxPlayers,dynamicDifficulty, isDynamic, instanceMapId, lfgID = GetInstanceInfo()
    difficulty_lastDungen = difficultyName

    if timer_Status == 0 then
        timer_Status = 1
        sell_value_total = 0
        sell_value_per_minute = 0
        looted_money_total = 0
        looted_money_per_minute = 0
        total_money = 0
        total_money_per_minute = 0
        LootedItems = {}
        LootedItemsQuantity = {}

        if LiveGold == "ON" then
            goldframe:Show()
            goldframe.goldlabel1:SetText(CopperToGold(0))
           
        end
        
        name_lastDungen = name
        t_start = GetTime()
        MyAddon:Print("Your run is being recorded.")
    end
end
function has_value (tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end